> For the complete documentation index, see [llms.txt](https://docs.pinot.apache.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pinot.apache.org/functions/aggregation/distinct_count_off_heap.md).

# DISTINCT\_COUNT\_OFF\_HEAP

This section contains reference documentation for the DISTINCT\_COUNT\_OFF\_HEAP function.

Returns the count of distinct values. The values are stored using off-heap memory.

## Signature

> DISTINCT\_COUNT\_OFF\_HEAP(col\[, params])

* `col` (required): Name of the column to aggregate on.
* `params` (optional): Semicolon-separated parameter key-value pairs:
  * `initialCapacity`: The initial capacity of the set for non-dictionary-encoded case (default *10000*).
  * `hashbits`: Number of bits for *murmur3*: *32*/*64*/*128* (default *64*)
* Example: `DISTINCT_COUNT_OFF_HEAP(col, 'initialCapacity=100000;hashbits=128')`

## Note

* For variable length data types such as `STRING` and `BYTES`, *murmur3* hash values are used to represent the values.
* Currently it only supports aggregate without group-by. For MV column, it only supports fixes lengh types.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pinot.apache.org/functions/aggregation/distinct_count_off_heap.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
